﻿@model webUI.SICO.Models.VoucherViewModel

@{
    ViewBag.Title = "Crear Comprobante";
}



<div class="row">
    <div class="col-md-12">
        <section class="block">
            <div class="block-header">
                <h3 class="block-title">@ViewBag.Title</h3>
                <div class="block-options">
                    <a href="../Home/Index/" class="btn btn-sm btn-secondary"><span class="fa fa-arrow-left"></span> Atr&aacute;s...</a>
                    <button type="button" title="Guardar" class="btn btn-sm btn-success" id="btnSave" onclick="fnSave()" disabled><span class="fa fa-plus"></span> Guardar</button>
                    <button type="button" title="Limpiar" class="btn btn-sm btn-warning" onclick="fnClear()"><span class="fa fa-eraser"></span> Limpiar</button>
                    <button type="button" class="btn-block-option" data-toggle="block-option" data-action="content_toggle"></button>
                </div>
            </div>
            <div class="block-content">
                <div class="container">
                    <div class="row">
                        <div class="col-md-4">
                            <div class="form-group">
                                <label for="selType" class="form-label">Tipo de Comprobante</label>
                                <select Id="selType" class="form-control"></select>
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group">
                                <label for="txtVoucherId" class="form-label">C&oacute;digo</label>
                                <label class="form-control" id="txtVoucherId"> </label>
                            </div>

                        </div>
                        <div class="col-md-4 col-md-offset-1">
                            <div class="form-group">
                                <label for="dtDate" class="form-label">Fecha</label>
                                <input type="date" id="dtDate" name="dtDate" value="@DateTime.Today.ToString("yyyy-MM-dd")" class="form-control" placeholder="dd/mm/yyyy" disabled>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <div class="form-group">
                                <label for="txtBeneficiary" class="form-label">Beneficiario</label>
                                <input type="text" class="form-control" id="txtBeneficiary" style="min-width:95%;" disabled>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <div class="form-group">
                                <label for="txtConcept" class="form-label">Concepto</label>
                                <input type="text" class="form-control" id="txtConcept" style="min-width:95%;" disabled>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <div class="form-group">
                                <label for="txtComments" class="form-label">Observaciones</label>
                                <textarea class="form-control" id="txtComments" rows="3" cols="12" style="min-width:95%;" disabled></textarea>
                            </div>
                        </div>
                    </div>
                </div>


            </div>

        </section>
    </div>
</div>


<div class="row">
    <div class="col-md-12">
        <section class="block">
            <div class="block-header">
                <h3 class="block-title">Detalles</h3>
                <div class="block-options">                    
                    <button type="button" class="btn-block-option" data-toggle="block-option" data-action="content_toggle"></button>
                </div>
            </div>
            <div class="block-content">
                <div class="container">
                    <div class="row">
                        <div class="col-md-2">
                            <div class="form-group">
                                <input type="text" class="form-control" id="txtAccount" placeholder="Cuenta" style="min-width:100%;" disabled>
                            </div>
                        </div>
                        <div class="col-md-5">
                            <div class="form-group">
                                <input type="text" class="form-control" id="txtDescription" placeholder="Concepto" style="min-width:100%;" disabled>
                            </div>
                        </div>
                        <div class="col-md-2">
                            <div class="form-group">
                                <input type="text" class="form-control" id="txtDebit" pattern="^\$\d{1,3}(,\d{3})*(\.\d+)?$" placeholder="Debe" data-type="currency" disabled>
                            </div>
                        </div>
                        <div class="col-md-2">
                            <div class="form-group">
                                <input type="text" class="form-control" id="txtCredit" pattern="^\$\d{1,3}(,\d{3})*(\.\d+)?$" placeholder="Haber" data-type="currency" disabled>
                            </div>
                        </div>
                        <div class="col-md-1">
                            <div class="form-group">
                                <button id="btnAdd" title="Agregar detalle" onclick="fnAdd()" class="btn btn-sm btn-success" disabled>
                                    <span class="fa fa-plus"></span>
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="table-responsive">
                    <table id="detail" class="table table-bordered table-striped table-vcenter">
                        <thead>
                            <tr>
                                <th width="60">Id</th>
                                <th width="100">Cuenta</th>
                                <th width="50%">Concepto</th>
                                <th width="60" class="numeric">Debe</th>
                                <th width="60" class="numeric">Haber</th>
                                <th width="40">Opciones</th>
                            </tr>
                        </thead>
                        <tbody></tbody>
                    </table>
                </div>


            </div>

        </section>
    </div>
</div>




@section Scripts {
    <script type="text/javascript">

        var _typeSelected = {};
        _typeSelected.Code = "";
        _typeSelected.Text = "";
        var _attached_info = [];
        var _counter = 0;
        var _debit = 0;
        var _credit = 0;

        fnGetTypes();

        $("#txtDebit").on("click", function () {
            $(this).select();
        });

        $("#txtCredit").on("click", function () {
            $(this).select();
        });




        $("#selType").change(function () {
            _typeSelected.Code = $(this).children("option:selected").val();
            _typeSelected.Value = $(this).children("option:selected").text();

            if (_typeSelected.Code == "NA") {
                $("#dtDate").prop('disabled', true);
                $("#txtBeneficiary").prop('disabled', true);
                $("#txtConcept").prop('disabled', true);
                $("#txtComments").prop('disabled', true);
                $("#txtVoucherId").html("");
                fnDeshabilitarDetalle(true);
            }
            else {
                $("#dtDate").prop('disabled', false);
                $("#txtBeneficiary").prop('disabled', false);
                $("#txtConcept").prop('disabled', false);
                $("#txtComments").prop('disabled', false);
                //$("#txtVoucherId").html(_typeSelected.Code + "001");
                $('#txtBeneficiary').focus();

                $("#selType").prop('disabled', true);
                fnDisableDetail(false);
            }

        });

        function fnDisableDetail(deshabilitar) {
            $("#txtAccount").prop('disabled', deshabilitar);
            $("#txtDescription").prop('disabled', deshabilitar);
            $("#txtDebit").prop('disabled', deshabilitar);
            $("#txtCredit").prop('disabled', deshabilitar);
            $("#btnAdd").prop('disabled', deshabilitar);
            if (deshabilitar) {
                $('#txtDebit').val("");
                $('#txtCredit').val("");
            }
            else {
                $('#txtDebit').val("");
                $('#txtCredit').val("");
            }
        }

        function fnGetTypes() {
            var url = "../VoucherType/GetVoucherTypes";
            $('#selType').empty();
            $('#selType').prepend($('<option></option>').html('Cargando...'));
            $("#selType").prop('disabled', true);
            $.ajax({
                type: "GET",
                data: {},
                url: url,
                success: function (data) {
                    if (data.Type == "E") {
                        toastr.error(data.Message, 'Error');
                        return false;
                    }
                    else {
                        $("#selType").prop('disabled', false);
                        $('#selType').empty();
                        $('#selType').prepend("<option value='NA' >--Seleccione una opcion--</option>");
                        $.each(data.Info, function (key, value) {
                            $('#selType').prepend("<option value='" + value.Code + "' >" + value.Value + "</option>");
                        });
                    }
                }
            });
        }

        function fnClear() {
            location.reload(true);
        }

        function fnAdd() {

            if (fnValidateDetails()) {
                fnAddDetail();
                $('#txtAccount').focus();
            }

        }

        function fnValidateDetails() {

            var nDebit = $('#txtDebit').val();
            var nCredit = $('#txtCredit').val();

            nDebit = nDebit.replaceAll(",", "");
            nCredit = nCredit.replaceAll(",", "");

            if ($('#txtAccount').val() == '') {
                toastr.warning('Debe agregar un numero de cuenta', 'Dato Faltante');
                return false;
            }
            if ($('#txtDescription').val() == '') {
                toastr.warning('Debe agregar una descripcion', 'Dato Faltante');
                return false;
            }
            if ($('#txtDebit').val() == '') {
                toastr.warning('Debe agregar un monto en el Debe', 'Dato Faltante');
                return false;
            }
            if ($('#txtCredit').val() == '') {
                toastr.warning('Debe agregar un monto en el Haber', 'Dato Faltante');
                return false;
            }
            if (isNaN(nDebit)) {
                toastr.warning('El valor del Debe tiene que ser numérico', 'Dato Faltante');
                return false;
            }
            if (isNaN(nCredit)) {
                toastr.warning('El valor del Haber tiene que ser numérico', 'Dato Faltante');
                return false;
            }
            var Debe = parseFloat($('#txtDebit').val());
            var Haber = parseFloat($('#txtCredit').val());
            if (Debe == 0 && Haber == 0) {
                toastr.warning('No puede agregar un detalle con valor 0 en el Haber y 0 en el Debe', 'Dato Faltante');
                return false;
            }

            if (Debe != 0 && Haber != 0) {
                toastr.warning('No puede agregar un detalle con montos en el Haber y en el Debe', 'Dato Erroneo');
                return false;
            }


            return true;
        }

        function fnAddDetail() {
            _counter++;
            var strDebit = $('#txtDebit').val().replaceAll(",", "");;
            var strCredit = $('#txtCredit').val().replaceAll(",", "");;
            _debit = _debit + parseFloat(strDebit);
            _credit = _credit + parseFloat(strCredit);

            _attached_info.push({ Id: _counter, Account: $('#txtAccount').val(), Description: $('#txtDescription').val(), Debit: $('#txtDebit').val(), Credit: $('#txtCredit').val() });

            $("#detail tbody").append("<tr><td>" + _counter + "</td><td>" + $('#txtAccount').val() + "</td><td>" + $('#txtDescription').val() + "</td><td>" + $('#txtDebit').val() + "</td><td>" + $('#txtCredit').val() + "</td><td>" +
                "<button title='Eliminar' onclick='fnRemoveDetail(" + _counter.toString() + ")' class='btn btn-sm btn-primary'><span class='fa fa-times'></span></button>" + "</td></tr>");
            fnClearDetail();
            $("#btnSave").prop('disabled', false);
        }
        function fnClearDetail() {
            $('#txtAccount').val("");

            $('#txtDescription').val("");

            $('#txtDebit').val("");

            $('#txtCredit').val("");
        }
        function fnRemoveDetail(id) {
            const index = _attached_info.findIndex(x => x.Id === id);
            if (index !== undefined) _attached_info.splice(index, 1);

            if (_attached_info.length <= 0) $("#btnSave").prop('disabled', true);
            fnRecargarDatos("");
        }

        function fnRecargarDatos(Disabled) {
            $("#detail tbody").empty();
            _counter = 0;
            _debit = 0;
            _credit = 0;

            $.each(_attached_info, function (index, value) {
                _counter++;
                _debit = _debit + parseFloat(value.Debit);
                _credit = _credit + parseFloat(value.Credit);
                value.Id = _counter;

                $("#detail tbody").append("<tr><td>" + _counter + "</td><td>" + value.Account + "</td><td>" + value.Description + "</td><td class='numeric'>" + value.Debit + "</td><td class='numeric'>" + value.Credit + "</td><td>" +
                    "<button onclick='fnRemoveDetail(" + _counter.toString() + ")' class='btn btn-sm btn-danger' " + Disabled + "><span class='fa fa-trash-o'></span></button>" + "</td></tr>");
            });
        }


        function fnSave() {
            One.layout('header_loader_on');
            var Url = "../Voucher/AddNewVoucher";
            var param = {};
            param.VoucherId = $("#txtVoucherId").html();
            param.VoucherDate = $('#dtDate').val();
            param.CreationDate = $('#dtDate').val();
            param.Concept = $('#txtConcept').val();
            param.Debit = _debit;
            param.Credit = _credit;
            param.IsEquivalent = (_debit == _credit);
            param.Comments = $('#txtComments').val();
            param.VoucherTypeId = _typeSelected.Code;
            param.Beneficiary = $('#txtBeneficiary').val();
            param.IsActive = true;
            param.Details = [];

            fnDisableDetail(true);
            $("#btnSave").prop('disabled', true);


            $.each(_attached_info, function (index, value) {
                var nDebit = value.Debit;
                var nCredit = value.Credit;

                nDebit = nDebit.replaceAll(",", "");
                nCredit = nCredit.replaceAll(",", "");

                param.Details.push({ VoucherId: param.VoucherId, VoucherDetailId: value.Id, Concept: value.Description, Debit: parseFloat(nDebit), Credit: parseFloat(nCredit), AccountId: value.Account, IsActive: true });
            });


            $.ajax({
                url: (Url),
                type: "POST",
                async: false,
                data: '{param:' + JSON.stringify(param) + '}',
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    if (data.Type == "E") {
                        toastr.error(data.Message, 'Error');
                        One.layout('header_loader_off');
                        return false;
                    }
                    else {
                        toastr.success('Comprobante guardado correctamente.', 'Exitoso');
                        $("#txtVoucherId").html(data.Message);
                        One.layout('header_loader_off');
                    }
                },
                error: function (result) {
                    toastr.error('Se produjo un error inesperado', 'Error');
                    One.layout('header_loader_off');
                }
            });



        }



        $("input[data-type='currency']").on({
            keyup: function () {
                formatCurrency($(this));
            },
            blur: function () {
                formatCurrency($(this), "blur");
            }
        });


        function formatNumber(n) {
            return n.replace(/\D/g, "").replace(/\B(?=(\d{3})+(?!\d))/g, ",")
        }


        function formatCurrency(input, blur) {
            var input_val = input.val();

            if (input_val === "") { return; }

            var original_len = input_val.length;

            var caret_pos = input.prop("selectionStart");

            if (input_val.indexOf(".") >= 0) {

                var decimal_pos = input_val.indexOf(".");

                var left_side = input_val.substring(0, decimal_pos);
                var right_side = input_val.substring(decimal_pos);

                left_side = formatNumber(left_side);

                right_side = formatNumber(right_side);
                if (blur === "blur") {
                    right_side += "00";
                }

                right_side = right_side.substring(0, 2);
                input_val = "" + left_side + "." + right_side;

            } else {
                input_val = formatNumber(input_val);
                input_val = "" + input_val;
                if (blur === "blur") {
                    input_val += ".00";
                }
            }
            input.val(input_val);
            var updated_len = input_val.length;
            caret_pos = updated_len - original_len + caret_pos;
            input[0].setSelectionRange(caret_pos, caret_pos);
        }



    </script>

    @Scripts.Render("~/bundles/jqueryval")
}
